unit parser;

interface

uses
  Classes, SysUtils, ParseExpr, Dialogs;

type

  { TForm1 }

  // Clase evaluador
  TEvaluador = class(TExpressionParser)
    private
      __x : double;
      __y : double;

    public
      function  DefineParser(ss : String; vx : char): boolean; overload;
      function  DefineParser(ss : String; vx,vy : char): boolean; overload;
      function  Eval(x   : double):double; overload;
      function  Eval(x,y : double):double; overload;
  end;

implementation

// Clase TEvaluador

function TEvaluador.DefineParser(ss : String; vx : char): boolean;
begin
  DefineParser := true;
  ClearExpressions;
  DefineVariable(vx, @__x);
  try
    AddExpression(ss);
  except on E : Exception do begin
      DefineParser := false;
      ShowMessage(E.Message);
    end;
  end;
end;

function TEvaluador.DefineParser(ss : String; vx,vy : char): boolean;
begin
  DefineParser := true;
  ClearExpressions;
  DefineVariable(vx, @__x);
  DefineVariable(vy, @__y);
  try
    AddExpression(ss);
  except on E : Exception do begin
      DefineParser := false;
      ShowMessage(E.Message);
    end;
  end;
end;

function TEvaluador.Eval(x : double):double;
begin
  __x := x;
  Eval := EvaluateCurrent;
end;

function TEvaluador.Eval(x,y : double):double;
begin
  __x := x;
  __y := y;
  Eval := EvaluateCurrent;
end;

initialization

end.

